include masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WND_DATA struct
	hdc		HDC ?
WND_DATA ends

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		
	.elseif uMsg == WM_CREATE
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
	
		invoke BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATPAINT
	
		invoke MoveToEx,ebx,0,0,0
		invoke LineTo,ebx,1000,1000
		invoke LineTo,ebx,0,1000
		invoke LineTo,ebx,1000,0
	
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main